```@meta
CurrentModule = LuxurySparse
```

# LuxurySparse

*A "Luxury" sparse matrix library for julia language.*

[LuxurySparse](https://github.com/QuantumBFS/LuxurySparse.jl) is a Julia package from [QuantumBFS](https://github.com/QuantumBFS). It aims to provide powerful sparse matrix types for Julia, which is initially motivated by [quantum simulation](https://quantumbfs.github.io/Yao.jl/latest/).

It contains
* more sparse matrix types like `IMatrix`, `PermMatrix` and `SparseMatrixCOO`,
* high performance `type convertion`, `kron` and `multiplication` operations.

## Manual

```@contents
Pages = [
    "luxurysparse.md",
]
Depth = 1
```
